;-128/64 KERNEL PARALLEL PORT DRIVER, STARTED 18-EP-1994.

;HIS DEVICE DRIVER USES THE PARALLEL PORT NETWORK CABLE DESCRIBED IN SSUE #8
;OF = ACKING NET MAGAZINE.  F YOU DON'T HAVE SUCH A CABLE, THEN DON'T
;INCLUDE THIS DEVICE IN YOUR DEVICE CONFIGURATION.

PARATA    = $DD01
PAR     = $DD03
PARLAG    = $DD0D
PARLAGAL = $10
PARASTP  .BUF 1 ;$00=READ, $01=WRITE, $FF=UNKNOWN
PAREADY   .BUF 1
PAREADOUNT .BUF 2

PARNIT = *
   LDA #$00
   STA PAREADY
   LDX #0
-  LDA CONFIGUF+0,X
   CMP #5
   BEQ +
   TXA
   CLC
   ADC #4
   TAX
   CPX #$80
   BCC -
   CLC
   RTS
   ;** GOT A LIVE ONE!
+  LDA #$00
   STA PAR
   STA PAREADOUNT+0
   STA PAREADOUNT+1
   LDA #$FF
   STA PARASTP
   STA PAREADY
   CLC
   RTS

PARPEN = *
   LDA OPENCB
   CLC
   RTS

PARLOSE = *
   LDA PARASTP
   CMP #$01
   BNE +
   LDA #$E6          ;WRITE  PACKET IF WE WERE LAST WRITER
   JSR PARRITEYTE
   LDA #$00
   JSR PARRITEYTE
   LDA #$00
   JSR PARRITEYTE
+  CLC
   JMP CLOSEDNTRY

PAREAD = *
   LDA PARASTP
   CMP #$01
   BNE +
   LDA #$00
   STA PAR
   LDA PARATA
+  LDA #$00
   STA PARASTP

   PAREADEADER = *
   LDA PAREADOUNT+0
   ORA PAREADOUNT+1
   BNE +
   JSR PAREADYTE
   CMP #$E6
   ;XX SHOULD CHECK IT HERE
   JSR PAREADYTE
   STA PAREADOUNT+0
   JSR PAREADYTE
   STA PAREADOUNT+1
   ORA PAREADOUNT+0
   BNE +
   JSR PAREADND  ;EOF
   LDX #$00
   RTS
+  LDA PAREADOUNT+0
   CMP READAXEN+0
   LDA PAREADOUNT+1
   SBC READAXEN+1
   BCS +
   LDA PAREADOUNT+0
   LDY PAREADOUNT+1
   STA READAXEN+0
   STY READAXEN+1
+  SEC
   LDA PAREADOUNT+0  ;SET COUNT FOR NEXT TIME
   SBC READAXEN+0
   STA PAREADOUNT+0
   LDA PAREADOUNT+1
   SBC READAXEN+1
   STA PAREADOUNT+1

   PAREADEXT = *
   LDA READENGTH+0
   CMP READAXEN+0
   LDA READENGTH+1
   SBC READAXEN+1
   BCC +
   PAREADND = *
   LDA READENGTH+0
   LDY READENGTH+1
   STA ZW+0
   STY ZW+1
   CLC
   LDX #$FF
   RTS
+  LDY #0
   LDA #PARLAGAL
-  BIT PARLAG
   BEQ -
   LDA PARATA
   STA (READTR),Y
   INC READTR+0
   BNE +
   INC READTR+1
+  INC READENGTH+0
   BNE +
   INC READENGTH+1
+  JMP PAREADEXT

PAREADYTE = *
   LDA #PARLAGAL
-  BIT PARLAG
   BEQ -
   LDA PARATA
   RTS

PARRITE = *
   LDA PARASTP
   CMP #$01
   BEQ PARRITEEADER
   LDX #$FF
   STX PAR
   CMP #$00
   BNE +
   LDA #PARLAGAL
-  BIT PARLAG
   BEQ -
+  LDA #$01
   STA PARASTP

   PARRITEEADER = *
   LDA WRITEENGTH+0
   ORA WRITEENGTH+1
   BNE +
   CLC
   RTS
+  LDA #$E6
   JSR PARRITEYTE
   LDA WRITEENGTH+0
   JSR PARRITEYTE
   LDA WRITEENGTH+1
   JSR PARRITEYTE

   PARRITEEXT = *
   LDA WRITEENGTH+0
   ORA WRITEENGTH+1
   BNE +
   CLC
   RTS
+  LDY #0
   LDA (WRITETR),Y
   STA PARATA
   INC WRITETR+0
   BNE +
   INC WRITETR+1
+  LDA WRITEENGTH+0
   BNE +
   DEC WRITEENGTH+1
+  DEC WRITEENGTH+0
   LDA #PARLAGAL
-  BIT PARLAG
   BEQ -
   JMP PARRITEEXT

PARRITEYTE = *
   STA PARATA
   LDA #PARLAGAL
-  BIT PARLAG
   BEQ -
   RTS

;THE END + BLANK LINE

