;-128/64 KERNEL RAMDISK DRIVER, STARTED 18-PR-1994.

RDIRENTENGTH  = 48
RDIRENTUF     .BUF RDIRENTENGTH
RDIRENTYTES   = ACEIRENTYTES-ACEIRENTUFFER+RDIRENTUF
RDIRENTATE    = ACEIRENTATE-ACEIRENTUFFER+RDIRENTUF
RDIRENTYPE    = ACEIRENTYPE-ACEIRENTUFFER+RDIRENTUF
RDIRENTLAGS   = ACEIRENTLAGS-ACEIRENTUFFER+RDIRENTUF
RDIRENTSAGE   = ACEIRENTSAGE-ACEIRENTUFFER+RDIRENTUF
RDIRENTAMEEN = ACEIRENTAMEEN-ACEIRENTUFFER+RDIRENTUF
RDIRENTAME    = ACEIRENTAME-ACEIRENTUFFER+RDIRENTUF
RDIRENTEADTR = RDIRENTUF+$24
RDIRENTAILTR = RDIRENTUF+$28
RDIRENTESERVED = RDIRENTUF+$2C
RDCBPENODE   = FCBABLE1+0  ;(1)
RDCBTATUS     = FCBABLE1+1  ;(1)
RDCBEXTIRENT = FCBABLE1+2  ;(4)
RDCBRPENODE  = FCBABLE1+0  ;(1)
RDCBREXTLK   = FCBABLE1+1  ;(3)
RDCBRILETR   = FCBABLE1+4  ;(4)
RDCBRLKYTES  = FCBABLE1+8  ;(2)

RDCBWPENODE  = FCBABLE1+0  ;(1)
RDCBWLKAGE   = FCBABLE1+1  ;(1)
RDCBWEMYTES  = FCBABLE1+2  ;(2)
RDCBWILETR   = FCBABLE1+4  ;(4)
RDCBWILEIZE  = FCBABLE1+8  ;(4)
RDCBWIRENT    = FCBABLE1+$C ;(4)

RDCBWUF .BUF 18
RDCBWUFPENODE = RDCBWPENODE-RDCBWPENODE+RDCBWUF
RDCBWUFLKAGE  = RDCBWLKAGE-RDCBWPENODE+RDCBWUF
RDCBWUFEMYTES = RDCBWEMYTES-RDCBWPENODE+RDCBWUF
RDCBWUFILETR  = RDCBWILETR-RDCBWPENODE+RDCBWUF
RDCBWUFILEIZE = RDCBWILEIZE-RDCBWPENODE+RDCBWUF
RDCBWUFIRENT   = RDCBWIRENT-RDCBWPENODE+RDCBWUF
RDNITNDEX .BUF 1

RDNIT = *
   LDX #0
   STX RDNITNDEX
-  LDX RDNITNDEX
   LDA CONFIGUF+0,X
   CMP #4
   BNE +
   JSR RDNITRIVE
+  CLC
   LDA RDNITNDEX
   ADC #4
   STA RDNITNDEX
   CMP #$80
   BCC -
   RTS

RDALLOCLAGS .BUF 1  ;XX NOT USED YET

RDARALLOC = *  ;( .=PAGESEQUESTED ) : .=ERR, [MP]=MEM, .=PAGESOTTEN
   JSR RDALLOC
   BCC +
   LDA ERRNO
   CMP #ACERRNSUFFICIENTEMORY
   BEQ ++
   SEC
+  RTS
+  LDA #1
   ;XX FALL THROUGH

RDALLOC = *  ;( .=PAGESEQUIRED ) : .=ERR, [MP]=MEM, .=PAGESOTTEN
   PHA
   PHA
   LDA #$FD
   STA ALLOCROC
   PLA
   LDX #$00
   LDY #$FF
   JSR KERNAGELLOC
   PLA
   RTS

RDREE = *  ;( [MP]=MEMTR, .=PAGES ) : .=ERR
   PHA
   LDA #$FD
   STA ALLOCROC
   PLA
   JSR KERNAGEREE
   RTS

RDNITRIVE = *  ;( RDNITNDEX )
   ;** ALLOC ROOT DIRENT, ROOT DIR CONTENTS
   LDA #2
   JSR RDALLOC
   BCC +
   RTS

   ;** INIT DEVICE TABLE ENTRY: ROOT DIR, CURRENT DIR
+  LDA RDNITNDEX
   ASL
   TAY
   LDA RDIRENTFFSETAB+0
   STA DEVICEABLE+0,Y
   STA DEVICEABLE+4,Y
   INY
   LDX #1
-  LDA MP,X
   STA DEVICEABLE+0,Y
   STA DEVICEABLE+4,Y
   INY
   INX
   CPX #4
   BCC -

   ;** INIT ROOT DIRENT
   JSR RDNITIRLOCKTRBUF
   LDX #RDIRENTENGTH-1
   LDA #0
-  STA RDIRENTUF,X
   DEX
   BPL -
   LDA #1
   STA RDIRENTYTES+1
   LDA #<RDIRENTATE
   LDY #>RDIRENTATE
   JSR GETDATE
   LDX #3
-  LDA RDOOTYPE,X
   STA RDIRENTYPE,X
   DEX
   BPL -
   LDA #%11110100
   STA RDIRENTLAGS
   LDA #13
   STA RDIRENTAMEEN
   LDX #16
-  LDA RDOOTAME,X
   STA RDIRENTAME,X
   DEX
   BPL -
   LDA RDNITNDEX
   LSR
   LSR
   CLC
   ADC #"@"
   STA RDIRENTAME+12
   LDA #%10000000
   STA RDIRENTSAGE
   LDX #3
-  LDA MP,X
   STA RDIRENTEADTR,X
   STA RDIRENTAILTR,X
   DEX
   BPL -
   INC RDIRENTEADTR+1
   INC RDIRENTAILTR+1
   LDX #RDIRENTENGTH-1
-  LDA RDIRENTUF,X
   STA WORKBUF+$10,X
   DEX
   BPL -
   LDA #<WORKBUF
   LDY #>WORKBUF
   STA ZP+0
   STY ZP+1
   LDA #<256
   LDY #>256
   JSR STASH

   ;** INIT ROOT DIR CONTENTS
   ;** "." ENTRY
   LDA #0
   STA RDIRENTYTES+1
   LDA #%01100100
   STA RDIRENTLAGS
   LDX #3
-  LDA RDOTYPE,X
   STA RDIRENTYPE,X
   DEX
   BPL -
   LDA #1
   STA RDIRENTAMEEN
   LDX #16
   LDA #0
-  STA RDIRENTAME,X
   DEX
   BPL -
   LDA #"."
   STA RDIRENTAME+0
   LDA #%11010000
   STA RDIRENTSAGE
   LDA #$10
   STA RDIRENTEADTR+0
   DEC RDIRENTEADTR+1
   LDX #RDIRENTENGTH-1
-  LDA RDIRENTUF,X
   STA WORKBUF+$10,X
   DEX
   BPL -
   ;** ".." ENTRY
   LDA #2
   STA RDIRENTAMEEN
   LDA #"."
   STA RDIRENTAME+1
   LDX #RDIRENTENGTH-1
-  LDA RDIRENTUF,X
   STA WORKBUF+$40,X
   DEX
   BPL -
   ;** STORE DIR BLOCK
   INC MP+1
   LDA #<256
   LDY #>256
   JSR STASH
   RTS

RDOOTAME = *
   .ASC "ACE-RAMDISK-A"
   .BYTE 0,0,0,0
RDOOTYPE = *
   .ASC "DIR"
   .BYTE 0
RDOTYPE = *
   .ASC "HLN"
   .BYTE 0
RDIRENTFFSETAB = *
   .BYTE $10,$40,$70,$A0,$D0

RDNITIRLOCKTRBUF = *
   LDX #0
   LDA #0
-  STA WORKBUF,X
   INX
   BNE -
   LDA #1
   STA WORKBUF+$00
   STA WORKBUF+$05
   LDA #ACEEMULL
   STA WORKBUF+$03
   RTS

RDCBFFSET .BUF 1
RDCBFFSET = RDCBFFSET
RDEVFFSET .BUF 1
RDPAVE .BUF 4
RDPAVE .BUF 2
RDOUNT .BUF 1
RDEGAVE .BUF 3

RDAVEPP = *
   LDX #3
-  LDA MP,X
   STA RDPAVE,X
   DEX
   BPL -
   LDA ZP+0
   LDY ZP+1
   STA RDPAVE+0
   STY RDPAVE+1
   RTS

RDESTOREPP = *
   LDX #3
-  LDA RDPAVE,X
   STA MP,X
   DEX
   BPL -
   LDA RDPAVE+0
   LDY RDPAVE+1
   STA ZP+0
   STY ZP+1
   RTS

RDIRPEN = *
RDPENREAMBLE = *
   LDA OPENEVICE
   ASL
   STA RDEVFFSET
   LDA OPENCB
   ASL
   ASL
   ASL
   ASL
   STA RDCBFFSET
   TAX
   LDA #"D"
   STA RDCBPENODE,X
   INX
   LDY #15
   LDA #0
-  STA RDCBPENODE,X
   INX
   DEY
   BNE -
   LDX RDCBFFSET
   LDA #$00
   STA RDCBTATUS,X
   LDY RDEVFFSET
   INY
   INY
   INY
   INY
   LDA #0
   STA RDOUNT
   LDX RDCBFFSET
-  LDA DEVICEABLE,Y
   STA RDCBEXTIRENT,X
   STX RDEGAVE+1
   LDX RDOUNT
   STA RDORKIR,X
   LDX RDEGAVE+1
   INX
   INY
   INC RDOUNT
   LDA RDOUNT
   CMP #4
   BCC -
   LDA OPENCB
   CLC
   RTS

RDIRLOSE = *
   JMP CLOSEDNTRY

;*** DIRREAD( .=DCB, .=DEVFGFF ) : .=EOF, ACEIRENTUFFER=DATA

RDCBUM .BUF 1

RDIREAD = *
   STX RDCBUM
   TYA
   ASL
   STA RDEVFFSET
   LDA RDCBUM
   ASL
   ASL
   ASL
   ASL
   STA RDCBFFSET
   JSR RDAVEPP
   LDX RDCBFFSET
   LDA RDCBPENODE,X
   CMP #"D"
   BEQ +
   LDA #ACERRILEOTNPUT
   JMP RDIREADRROR
+  LDA RDCBTATUS,X
   CMP #$00
   BEQ RDIREADITLE
   CMP #$01
   BNE +
   JMP RDIREADIRENT
+  LDA #0
   STA ACEIRENTAMEEN
   STA ACEIRENTAME+0
   CLC
   ;** FALL THROUGH
RDIREADXIT = *
   PHP
   JSR RDESTOREPP
   PLP
   RTS
RDIREADRROR = *
   STA ERRNO
   SEC
   LDA #0
   JMP RDIREADXIT

RDIREADITLE = *
   LDX RDCBFFSET
   LDA #$01
   STA RDCBTATUS,X
   LDY #0
-  LDA RDCBEXTIRENT,X
   STA MP,Y
   INX
   INY
   CPY #4
   BCC -
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR FETCH
   LDX #ACEIRENTENGTH-1
-  LDA RDIRENTUF,X
   STA ACEIRENTUFFER,X
   DEX
   BPL -
   LDX RDCBFFSET
   LDY #0
-  LDA RDIRENTEADTR,Y
   STA RDCBEXTIRENT,X
   INX
   INY
   CPY #4
   BCC -
   LDX RDCBFFSET
   LDA #$10
   STA RDCBEXTIRENT+0,X
   LDA #$FF
   CLC
   JMP RDIREADXIT

RDIREADIRENT = *
   LDX RDCBFFSET
   LDY #0
-  LDA RDCBEXTIRENT,X
   STA MP,Y
   INX
   INY
   CPY #4
   BCC -
   LDA MP+0
   CMP #$FF
   BEQ RDIREADEXTLOCK
   LDX RDCBFFSET
   CLC
   ADC #RDIRENTENGTH
   BCC +
   LDA #$FF
+  STA RDCBEXTIRENT+0,X
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR FETCH
   LDA RDIRENTSAGE
   BPL RDIREADIRENT
   LDX #ACEIRENTENGTH-1
-  LDA RDIRENTUF,X
   STA ACEIRENTUFFER,X
   DEX
   BPL -
   LDA #$FF
   CLC
   JMP RDIREADXIT

RDLOCKEAD .BUF 6
RDHAGES   = RDLOCKEAD+0
RDHEXTG  = RDLOCKEAD+1
RDHYTES   = RDLOCKEAD+4

   RDIREADEXTLOCK = *
   LDA #$00
   STA MP+0
   LDA #<RDLOCKEAD
   LDY #>RDLOCKEAD
   STA ZP+0
   STY ZP+1
   LDA #6
   LDY #0
   JSR FETCH
   LDA RDHEXTG+2
   CMP #ACEEMULL
   BEQ RDIREADREE
   LDX RDCBFFSET
   LDA #$10
   STA RDCBEXTIRENT+0,X
   INX
   LDY #0
-  LDA RDHEXTG,Y
   STA RDCBEXTIRENT,X
   INX
   INY
   CPY #3
   BCC -
   JMP RDIREADIRENT

RDIREADREE = *
   LDX RDCBFFSET
   LDA #$FF
   STA RDCBTATUS,X
   LDA #0
   LDX #ACEIRENTENGTH-1
-  STA ACEIRENTUFFER,X
   DEX
   BPL -
   LDX #3
-  LDA ACEREEEMORY,X
   STA ACEIRENTYTES,X
   DEX
   BPL -
   LDA #%01000100
   STA ACEIRENTLAGS
   LDA #%00000000
   STA ACEIRENTSAGE
   JSR RDESTOREPP
   LDA #$FF
   CLC
   RTS

RDHIR = *
   LDA #0
   STA STRINGUFFER+2
   JMP CHDIRETAME

RDILEYPE .BUF 1

RDPEN = *
   JSR RDPENREAMBLE
   JSR RDAVEPP
   LDY OPENAMECAN
   LDX #0
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INX
   INY
   BNE -
+  LDA #"S"
   STA RDILEYPE
   LDA STRINGUFFER-2,X
   CMP #","
   BNE +
   LDA STRINGUFFER-1,X
   STA RDILEYPE
   LDA #0
   STA STRINGUFFER-2,X
+  LDX RDCBFFSET
   LDA OPENODE
   STA RDCBRPENODE,X
   CMP #"R"
   BEQ +
   JMP RDPENRITE

   ;** OPEN FOR READ
+  JSR RDCANIR
   BCC +
   LDA ERRNO
   JMP RDPENRROR
+  LDX RDCBFFSET
   LDA #0
   STA RDCBRLKYTES+0,X
   STA RDCBRLKYTES+1,X
   LDY #0
-  LDA RDIRENTEADTR+1,Y
   STA RDCBREXTLK,X
   INX
   INY
   CPY #3
   BCC -
   JSR RDESTOREPP
   LDA OPENCB
   CLC
   RTS

   RDPENRITE = *
   CMP #"W"
   BEQ +
   JMP RDPENPPEND
+  JSR RDCANIR
   BCS +
   LDA #ACERRILEXISTS
   RDPENRROR = *
   PHA
   JSR RDESTOREPP
   PLA
   STA ERRNO
   LDX OPENCB
   LDA #LFNULL
   STA LFTABLE,X
   SEC
   LDA #FCBULL
   RTS
+  LDA RDREEIRENT+3
   CMP #ACEEMULL
   BNE +
   JSR RDDDIRLOCK
   BCC +
   LDA #ACERRISKULL
   JMP RDPENRROR
   ;** INITIALIZE DIRECTORY ENTRY
+  LDX #RDIRENTENGTH-1
   LDA #0
-  STA RDIRENTUF,X
   DEX
   BPL -
   LDA #$00
   STA STRINGUFFER+16
   LDX #$FF
-  INX
   LDA STRINGUFFER,X
   STA RDIRENTAME,X
   BNE -
   STX RDIRENTAMEEN
   LDA #<RDIRENTATE
   LDY #>RDIRENTATE
   JSR GETDATE
   LDY #0
   LDA RDILEYPE
   CMP #"P"
   BNE +
   LDY #4
+  LDX #0
-  LDA RDPENRITEYPES,Y
   STA RDIRENTYPE,X
   INY
   INX
   CPX #4
   BCC -
   LDA #%01101100
   STA RDIRENTLAGS
   LDA #%10000000
   STA RDIRENTSAGE
   LDX #3
-  LDA #ACEEMULL
   STA RDIRENTEADTR,X
   STA RDIRENTAILTR,X
   DEX
   BPL -
   ;** INITIALIZE FCB BUFFER
   LDX #15
   LDA #$00  ;XX ASSUME NULL=$00
-  STA RDCBWUFPENODE,X
   DEX
   BPL -
   LDA #"W"
   STA RDCBWUFPENODE
   LDX #3
-  LDA RDREEIRENT,X
   STA RDCBWUFIRENT,X
   STA MP,X
   DEX
   BPL -
   ;** WRITE DIRECTORY ENTRY
   RDPENRITELUSH = *
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR STASH
   ;** WRITE FCB ENTRY
   LDX #0
   LDY RDCBFFSET
-  LDA RDCBWUFPENODE,X
   STA RDCBWPENODE,Y
   INY
   INX
   CPX #16
   BCC -
   JSR RDESTOREPP
   LDA OPENCB
   CLC
   RTS

RDPENRITEYPES = *
   .ASC "SEQ"
   .BYTE $00
   .ASC "PRG"
   .BYTE $00

   RDPENPPEND = *
   CMP #"A"
   BEQ +
   LDA #ACERRNVALIDILEODE
   JMP RDPENRROR
+  JSR RDCANIR
   BCC +
   LDA ERRNO
   JMP RDPENRROR
+  LDA RDIRENTLAGS
   BPL +
   LDA #ACERRPENIRECTORY
   JMP RDPENRROR
+  AND #%00100000
   BNE +
   LDA #ACERRERMISSIONENIED
   JMP RDPENRROR
+  LDA RDIRENTLAGS
   ORA #%00001000
   STA RDIRENTLAGS
   LDA #<RDIRENTATE
   LDY #>RDIRENTATE
   JSR GETDATE
   LDA #"W"
   STA RDCBWUFPENODE
   LDX #3
-  LDA RDIRENTAILTR,X
   STA RDCBWUFILETR,X
   STA MP,X
   LDA RDIRENTYTES,X
   STA RDCBWUFILEIZE,X
   LDA RDIRENTTR,X
   STA RDCBWUFIRENT,X
   DEX
   BPL -
   LDA #$06
   STA RDCBWUFILETR+0
   LDA RDCBWUFILETR+1
   STA RDCBWUFLKAGE   ;%%%
   LDA #<RDPENLKDR
   LDY #>RDPENLKDR
   STA ZP+0
   STY ZP+1
   LDA #6
   LDY #0
   JSR FETCH
   CLC
   LDA RDCBWUFILETR+0
   ADC RDPENLKDR+4
   STA RDCBWUFILETR+0
   LDA RDCBWUFILETR+1
   ADC RDPENLKDR+5
   STA RDCBWUFILETR+1
   SEC
   LDA #250
   SBC RDPENLKDR+4
   STA RDCBWUFEMYTES+0
   LDX RDPENLKDR+0
   DEX
   TXA
   SBC RDPENLKDR+5
   STA RDCBWUFEMYTES+1
   LDX #3
-  LDA RDIRENTTR,X
   STA MP,X
   DEX
   BPL -
   JMP RDPENRITELUSH

RDPENLKDR .BUF 6

RDORKIR       .BUF 4
RDIRENTTR     .BUF 4
RDREEIRENT    .BUF 4
RDCANIRFFSET .BUF 1

RDCANIR = *  ;( STRINGUFFER=FILENAME, [RDORKIR] ) : [RDIRENTTR]=DIRENT
   LDX #3
-  LDA RDORKIR,X
   STA MP,X
   LDA #ACEEMULL
   STA RDREEIRENT,X
   DEX
   BPL -
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR FETCH
   LDX #3
-  LDA RDIRENTEADTR,X
   STA MP,X
   DEX
   BPL -
   LDA #<WORKBUF
   LDY #>WORKBUF
   STA ZP+0
   STY ZP+1

   RDCANIREXTLOCK = *
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   LDA #ACERRILEOTOUND
   STA ERRNO
   SEC
   RTS
+  LDA #<256
   LDY #>256
   JSR FETCH
   LDA #$10
   STA RDCANIRFFSET

   RDCANIREXTIRENT = *
   LDX RDCANIRFFSET
   LDA RDIRENTSAGE-RDIRENTUF+WORKBUF,X
   BMI +
   LDA RDREEIRENT+3
   CMP #ACEEMULL
   BNE RDCANIRONTINUE
   LDX #3
-  LDA MP,X
   STA RDREEIRENT,X
   DEX
   BPL -
   LDA RDCANIRFFSET
   STA RDREEIRENT+0
   JMP RDCANIRONTINUE
+  LDY #0
-  LDA RDIRENTAME-RDIRENTUF+WORKBUF,X
   CMP STRINGUFFER,Y
   BNE RDCANIRONTINUE
   INX
   INY
   CMP #0
   BNE -
   LDA RDCANIRFFSET
   STA MP+0
   LDX #3
-  LDA MP,X
   STA RDIRENTTR,X
   DEX
   BPL -
   LDX RDCANIRFFSET
   LDY #0
-  LDA WORKBUF,X
   STA RDIRENTUF,Y
   INX
   INY
   CPY #RDIRENTENGTH
   BCC -
   CLC
   RTS

   RDCANIRONTINUE = *
   CLC
   LDA RDCANIRFFSET
   ADC #RDIRENTENGTH
   STA RDCANIRFFSET
   BCC RDCANIREXTIRENT
   LDX #3
-  LDA WORKBUF,X
   STA MP,X
   DEX
   BPL -
   LDA #$00
   STA MP+0
   JMP RDCANIREXTLOCK

RDDDIRLOCK = *  ;( [RDORKIR] ) : [RDREEIRENT], .=ERR
   ;** ALLOC NEW BLOCK
   LDA #$00 ;XX
   STA RDALLOCLAGS
   LDA #1
   JSR RDALLOC
   BCC +
   LDA #ACERRISKULL
   STA ERRNO
   SEC
   RTS
   ;** INIT NEW BLOCK
+  JSR RDNITIRLOCKTRBUF
   LDA #<WORKBUF
   LDY #>WORKBUF
   STA ZP+0
   STY ZP+1
   LDA #<256
   LDY #>256
   JSR STASH
   LDX #3
-  LDA MP,X
   STA RDREEIRENT,X
   DEX
   BPL -

   ;** MODIFY WORKING DIRECTORY DIRENT
   LDX #3
-  LDA RDORKIR,X
   STA MP,X
   DEX
   BPL -
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR FETCH
   LDX #3
-  LDA RDIRENTAILTR,X
   STA RDREVLKTR,X
   LDA RDREEIRENT,X
   STA RDIRENTAILTR,X
   DEX
   BPL -
   LDA #RDIRENTENGTH
   LDY #0
   JSR STASH
   ;** LINK PREVIOUS DIR BLOCK
   LDX #3
-  LDA RDREVLKTR,X
   STA MP,X
   DEX
   BPL -
   LDA #$01
   STA MP+0
   LDA #<RDIRENTAILTR+1
   LDY #>RDIRENTAILTR+1
   STA ZP+0
   STY ZP+1
   LDA #3
   LDY #0
   JSR STASH
   ;** CLEAN UP
   LDA #$10
   STA RDREEIRENT+0
   CLC
   RTS

RDREVLKTR .BUF 4

RDEADHUNK = SYSWORK+8
RDCBRUF .BUF 12
RDCBRUFPENODE = RDCBRPENODE-RDCBRPENODE+RDCBRUF
RDCBRUFEXTLK  = RDCBREXTLK-RDCBRPENODE+RDCBRUF
RDCBRUFILETR  = RDCBRILETR-RDCBRPENODE+RDCBRUF
RDCBRUFLKYTES = RDCBRLKYTES-RDCBRPENODE+RDCBRUF

RDEAD = *  ;( ) :.=(ZW)=LEN,.=EOF
   LDA READCB
   ASL
   ASL
   ASL
   ASL
   STA RDCBFFSET
   JSR RDAVEPP
   LDX RDCBFFSET
   LDY #0
-  LDA RDCBRPENODE,X
   STA RDCBRUF,Y
   INX
   INY
   CPY #10
   BCC -
   LDA RDCBRUFPENODE
   CMP #"R"
   BEQ RDEADORE
   LDA #ACERRILEOTNPUT

   RDEADRROR = *
   STA ERRNO
   LDA #0
   LDY #0
   SEC
   RDEADXIT = *
   PHP
   STA ZW+0
   STY ZW+1
   LDY #0
   LDX RDCBFFSET
-  LDA RDCBRUF,Y
   STA RDCBRPENODE,X
   INX
   INY
   CPY #10
   BCC -
   JSR RDESTOREPP
   LDA ZW+0
   LDY ZW+1
   PLP
   RTS

   RDEADORE = *
   LDA READAXEN+0
   ORA READAXEN+1
   BNE +
-  LDA READENGTH+0
   ORA READENGTH+1
   PHP
   LDA READENGTH+0
   LDY READENGTH+1
   PLP
   CLC
   JMP RDEADXIT
+  LDA RDCBRUFLKYTES+0
   LDY RDCBRUFLKYTES+1
   STA RDEADHUNK+0
   STY RDEADHUNK+1
   ORA RDEADHUNK+1
   BNE +
   LDA #$06
   STA RDCBRUFILETR+0
   LDA #$00
   STA MP+0
   LDX #2
-  LDA RDCBRUFEXTLK,X
   STA RDCBRUFILETR+1,X
   STA MP+1,X
   DEX
   BPL -
   LDA MP+3
   CMP #ACEEMULL
   BEQ --
   LDA #<WORKBUF
   LDY #>WORKBUF
   STA ZP+0
   STY ZP+1
   LDA #6
   LDY #0
   JSR FETCH
   LDA WORKBUF+$04
   LDY WORKBUF+$05
   STA RDCBRUFLKYTES+0
   STY RDCBRUFLKYTES+1
   LDX #2
-  LDA WORKBUF+$01,X
   STA RDCBRUFEXTLK,X
   DEX
   BPL -
   JMP RDEADORE

+  LDA RDEADHUNK+0
   CMP READAXEN+0
   LDA RDEADHUNK+1
   SBC READAXEN+1
   BCC +
   LDA READAXEN+0
   LDY READAXEN+1
   STA RDEADHUNK+0
   STY RDEADHUNK+1
+  LDX #3
-  LDA RDCBRUFILETR,X
   STA MP,X
   DEX
   BPL -
   LDA READTR+0
   LDY READTR+1
   STA ZP+0
   STY ZP+1
   LDA RDEADHUNK+0
   LDY RDEADHUNK+1
   JSR FETCH

   CLC
   LDA READTR+0
   ADC RDEADHUNK+0
   STA READTR+0
   LDA READTR+1
   ADC RDEADHUNK+1
   STA READTR+1
   CLC
   LDA READENGTH+0
   ADC RDEADHUNK+0
   STA READENGTH+0
   LDA READENGTH+1
   ADC RDEADHUNK+1
   STA READENGTH+1
   CLC
   LDA RDCBRUFILETR+0
   ADC RDEADHUNK+0
   STA RDCBRUFILETR+0
   LDA RDCBRUFILETR+1
   ADC RDEADHUNK+1
   STA RDCBRUFILETR+1
   SEC
   LDA READAXEN+0
   SBC RDEADHUNK+0
   STA READAXEN+0
   LDA READAXEN+1
   SBC RDEADHUNK+1
   STA READAXEN+1
   SEC
   LDA RDCBRUFLKYTES+0
   SBC RDEADHUNK+0
   STA RDCBRUFLKYTES+0
   LDA RDCBRUFLKYTES+1
   SBC RDEADHUNK+1
   STA RDCBRUFLKYTES+1
   JMP RDEADORE

RDFGFFSET .BUF 1
RDRITEHUNK = SYSWORK+4

RDRITE = *  ;( WRITEENGTH, WRITETR ) : (ZP)=DATATART
   STX RDFGFFSET
   LDA CONFIGUF+$03,X
   STA RDALLOCLAGS
   LDA REGSAVE+1  ;FD
   ASL
   ASL
   ASL
   ASL
   STA RDCBFFSET
   JSR RDAVEPP
   LDX RDCBFFSET
   LDY #0
-  LDA RDCBWPENODE,X
   STA RDCBWUF,Y
   INX
   INY
   CPY #16
   BCC -
   LDA RDCBWUFPENODE
   CMP #"W"
   BEQ RDRITEORE
   LDA #ACERRILEOTUTPUT

   RDRITERROR = *
   STA ERRNO
   LDA #0
   LDY #0
   SEC
   RDRITEXIT = *
   PHP
   LDY #0
   LDX RDCBFFSET
-  LDA RDCBWUF,Y
   STA RDCBWPENODE,X
   INX
   INY
   CPY #16
   BCC -
   JSR RDESTOREPP
   PLP
   RTS

   RDRITEORE = *
   LDA WRITEENGTH+0
   ORA WRITEENGTH+1
   BNE +
   CLC
   JMP RDRITEXIT
   ;** GET NEW BLOCK IF OLD ONE FULL
+  LDA RDCBWUFEMYTES+0
   ORA RDCBWUFEMYTES+1
   BEQ +
   JMP RDRITEOPY
   ;** GET NEW BLOCK
+  LDX WRITEENGTH+1
   LDA WRITEENGTH+0
   BEQ +
   INX
+  TXA
   JSR RDARALLOC
   BCC +
   LDA #ACERRISKULL
   JMP RDRITERROR
+  TAX
   LDA #0
   SEC
   SBC #6
   STA RDCBWUFEMYTES+0
   TXA
   SBC #0
   STA RDCBWUFEMYTES+1
   ;** INITIALIZE NEW BLOCK
   STX RDEWLKATA+0
   LDA #<RDEWLKATA
   LDY #>RDEWLKATA
   STA ZP+0
   STY ZP+1
   LDA #6
   LDY #0
   JSR STASH  ;NECESSARY?
   ;** LINK IN BLOCK, INIT FCB
   SEC
   LDA RDCBWUFILETR+1
   SBC RDCBWUFLKAGE
   SEC
   SBC #1
   STA RDLDLKATA+5
   LDA #250
   STA RDLDLKATA+4
   LDX #3
-  LDA MP,X
   LDY RDCBWUFILETR,X
   STA RDCBWUFILETR,X
   STA RDLDLKATA,X
   STY MP,X
   DEX
   BPL -
   LDA RDCBWUFLKAGE
   STA MP+1
   LDA #$01
   STA MP+0
   LDA RDCBWUFILETR+1
   STA RDCBWUFLKAGE
   LDA #<RDLDLKATA+1
   LDY #>RDLDLKATA+1
   STA ZP+0
   STY ZP+1
   LDA #5
   LDX MP+3
   CPX #ACEEMULL
   BNE +
   LDX #3
-  LDA RDCBWUFIRENT,X
   STA MP,X
   DEX
   BPL -
   CLC
   LDA MP+0
   ADC #RDIRENTEADTR-RDIRENTUF+1
   STA MP+0
   LDA #3
+  LDY #0
   JSR STASH
   LDA #$06
   STA RDCBWUFILETR+0

   ;** COPY DATA INTO BLOCK
   RDRITEOPY = *
   LDX WRITEENGTH+0
   LDY WRITEENGTH+1
   CPX RDCBWUFEMYTES+0
   TYA
   SBC RDCBWUFEMYTES+1
   BCC +
   LDX RDCBWUFEMYTES+0
   LDY RDCBWUFEMYTES+1
+  STX RDRITEHUNK+0
   STY RDRITEHUNK+1
   LDX #3
-  LDA RDCBWUFILETR,X
   STA MP,X
   DEX
   BPL -
   LDA WRITETR+0
   LDY WRITETR+1
   STA ZP+0
   STY ZP+1
   LDA RDRITEHUNK+0
   LDY RDRITEHUNK+1
   JSR STASH

   ;** UPDATE CONTROL VARIABLES
   CLC
   LDA RDCBWUFILETR+0
   ADC RDRITEHUNK+0
   STA RDCBWUFILETR+0
   LDA RDCBWUFILETR+1
   ADC RDRITEHUNK+1
   STA RDCBWUFILETR+1
   SEC
   LDA RDCBWUFEMYTES+0
   SBC RDRITEHUNK+0
   STA RDCBWUFEMYTES+0
   LDA RDCBWUFEMYTES+1
   SBC RDRITEHUNK+1
   STA RDCBWUFEMYTES+1
   CLC
   LDA WRITETR+0
   ADC RDRITEHUNK+0
   STA WRITETR+0
   LDA WRITETR+1
   ADC RDRITEHUNK+1
   STA WRITETR+1
   SEC
   LDA WRITEENGTH+0
   SBC RDRITEHUNK+0
   STA WRITEENGTH+0
   LDA WRITEENGTH+1
   SBC RDRITEHUNK+1
   STA WRITEENGTH+1
   CLC
   LDA RDCBWUFILEIZE+0
   ADC RDRITEHUNK+0
   STA RDCBWUFILEIZE+0
   LDA RDCBWUFILEIZE+1
   ADC RDRITEHUNK+1
   STA RDCBWUFILEIZE+1
   BCC +
   INC RDCBWUFILEIZE+2
   BNE +
   INC RDCBWUFILEIZE+3
+  JMP RDRITEORE

RDEWLKATA = * ;GETS MODIFIED
   .BYTE $00
   .BYTE ACEEMULL,ACEEMULL,ACEEMULL
   .BYTE $00,$00
RDLDLKATA = * ;GETS MODIFIED
   .BYTE $00
   .BYTE ACEEMULL,ACEEMULL,ACEEMULL
   .BYTE 250,$00

RDLOSE = *  ;( CLOSED )
   LDA CLOSED
   ASL
   ASL
   ASL
   ASL
   STA RDCBFFSET
   TAX
   LDA RDCBRPENODE,X
   CMP #"W"
   BEQ +
   RTS
+  LDY #0
-  LDA RDCBWPENODE,X
   STA RDCBWUF,Y
   INX
   INY
   CPY #16
   BCC -
   JSR RDAVEPP
   ;** TIDY UP LAST BLOCK CONTROL INFO
   LDX #3
-  LDA RDCBWUFILETR,X
   STA MP,X
   DEX
   BPL -
   LDA RDCBWUFLKAGE
   STA MP+1
   LDA #$01
   STA MP+0
   SEC
   LDA RDCBWUFILETR+0
   SBC #$06
   STA RDLDLKATA+4
   LDA RDCBWUFILETR+1
   SBC RDCBWUFLKAGE
   STA RDLDLKATA+5
   LDA #ACEEMULL
   STA RDLDLKATA+1
   STA RDLDLKATA+2
   STA RDLDLKATA+3
   LDA #<RDLDLKATA+1
   LDY #>RDLDLKATA+1
   STA ZP+0
   STY ZP+1
   LDA #5
   LDY #0
   JSR STASH
   ;** TIDY UP DIRECTORY ENTRY
   LDX #3
-  LDA MP,X
   STA RDCBWUFILETR,X
   LDA RDCBWUFIRENT,X
   STA MP,X
   DEX
   BPL -
   LDA #$00
   STA RDCBWUFILETR+0
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR FETCH
   LDA RDIRENTLAGS
   AND #%11110111
   STA RDIRENTLAGS
   LDX #3
-  LDA RDCBWUFILETR,X
   STA RDIRENTAILTR,X
   LDA RDCBWUFILEIZE,X
   STA RDIRENTYTES,X
   DEX
   BPL -
   LDA #RDIRENTENGTH
   LDY #0
   JSR STASH
   JSR RDESTOREPP
   RTS

RDLOADDDR  .BUF 2
RDLOADOP   .BUF 2
RDLOADEN   .BUF 2
RDLOADD    .BUF 1
RDLOADYTES .BUF 2
RDLOADAME  .BUF 2
RDLOADND   .BUF 2

RDLOAD = *
   ;** BINARY-LOAD A FILE
   ;** THIS ROUTINE IS FAIRLY HIGH-LEVEL AND CALLS THE REGULAR FILE SYSTEM
   ;** CALLS; MAKE SURE ONE FCB IS FREE
   LDX #1
-  LDA BLOADDDRESS,X
   STA RDLOADDDR,X
   LDA ZP,X
   STA RDLOADAME,X
   DEX
   BPL -
   SEC
   LDA ZW+0
   STA RDLOADOP+0
   SBC BLOADDDRESS+0
   STA RDLOADEN+0
   LDA ZW+1
   STA RDLOADOP+1
   SBC BLOADDDRESS+1
   STA RDLOADEN+1
   ;** (ZP) ALREADY CONTAINS FILENAME
   LDA #"R"
   JSR OPEN
   STA RDLOADD
   BCC +
   RTS
+  LDA #<RDLOADYTES
   LDY #>RDLOADYTES
   STA ZP+0
   STY ZP+1
   LDA #2
   LDY #0
   LDX RDLOADD
   JSR READ
   BCS RDLOADRRLOSE
   LDA RDLOADDDR+0
   LDY RDLOADDDR+1
   STA ZP+0
   STY ZP+1
   LDA RDLOADEN+0
   LDY RDLOADEN+1
   LDX RDLOADD
   JSR READ
   BCC +
   RDLOADRRLOSE = *
   LDA ERRNO
   PHA
   LDA RDLOADD
   JSR CLOSE
   PLA
   STA ERRNO
   JSR RDLOADLEANUP
   SEC
   RTS

+  CLC
   ADC RDLOADDDR+0
   STA RDLOADND+0
   TYA
   ADC RDLOADDDR+1
   STA RDLOADND+1
   LDA #<RDLOADYTES
   LDY #>RDLOADYTES
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   LDX RDLOADD
   JSR READ
   BEQ +

   LDA #ACERRLOADRUNCATED
   STA ERRNO
   JMP RDLOADRRLOSE

+  LDA RDLOADD
   JSR CLOSE
   RDLOADLEANUP = *
   LDX #1
-  LDA RDLOADAME,X
   STA ZP,X
   LDA RDLOADOP,X
   STA ZW,X
   DEX
   BPL -
   LDA RDLOADND+0
   LDY RDLOADND+1
   CLC
   RTS

RDXTRACTILETYPE = *  ;( STRINGUFFER, .=STRLEN ) : .=FILETYPE, STRUF
   LDA #"S"
   CPX #2
   BCS +
-  LDA #"S"
   SEC
   RTS
+  LDA STRINGUFFER-2,X
   CMP #","
   BNE -
   LDA #0
   STA STRINGUFFER-2,X
   LDA STRINGUFFER-1,X
   CLC
   RTS

RDEMOVEEVICE .BUF 1
RDEMOVELKDR .BUF 7
RDUMMY .BUF 1

RDEMOVE = *  ;( .=DEVICE, .=SCANOS ) : .=OK
   STA RDEMOVEEVICE
   ;** FETCH FILENAME STRING FOR DIR-SCAN
   LDX #0
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INX
   INY
   BNE -
+  JSR RDXTRACTILETYPE
   JSR RDAVEPP
   ;** GET WORKING DIRECTORY FOR DIR-SCAN
   LDA RDEMOVEEVICE
   ASL
   TAY
   INY
   INY
   INY
   INY
   LDX #0
-  LDA DEVICEABLE,Y
   STA RDORKIR,X
   INY
   INX
   CPX #4
   BCC -
   ;** SCAN DIRECTORY, GET FILE ENTRY
   JSR RDCANIR
   BCC +
   JSR RDESTOREPP
   SEC
   RTS
   ;** REMOVE ALL BLOCKS OF FILE
+  LDX #3
-  LDA RDIRENTEADTR,X
   STA MP,X
   DEX
   BPL -
   RDEMOVEEXTLOCK = *
   LDA MP+3
   CMP #ACEEMULL
   BEQ RDEMOVEIRENT
   ;*** FETCH BLOCK HEADER
   LDA #<RDEMOVELKDR
   LDY #>RDEMOVELKDR
   STA ZP+0
   STY ZP+1
   LDA #6
   LDY #0
   JSR FETCH
   ;*** FREE BLOCK
   LDA RDEMOVELKDR+0
   JSR RDREE
   ;*** GO TO NEXT BLOCK
   LDX #2
-  LDA RDEMOVELKDR+1,X
   STA MP+1,X
   DEX
   BPL -
   LDA #0
   STA MP+0
   JMP RDEMOVEEXTLOCK
   
   ;** MARK DIRECTORY ENTRY DELETED
   RDEMOVEIRENT = *
   LDA RDIRENTSAGE
   AND #%01111111
   STA RDIRENTSAGE
   ;** WRITE OUT UPDATED DIRECTORY ENTRY
   LDX #3
-  LDA RDIRENTTR,X
   STA MP,X
   DEX
   BPL -
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR STASH
   ;** TIDY UP AND EXIT
   JSR RDESTOREPP
   CLC
   RTS

RDENAMEEVICE .BUF 1
RDENAMECAN   .BUF 1
RDENAMEYPE   .BUF 1
RDENAMEEWAME .BUF 17

RDENAME = *  ;( .=DEVICE, .=SCANOS ) : .=OK
   STA RDENAMEEVICE
   STY RDENAMECAN
   ;** SCAN FOR NEW NAME (SHOULD NOT EXIST)
   LDY #0
   LDX #0
-  LDA (ZW),Y
   STA STRINGUFFER,X
   BEQ +
   INX
   INY
   BNE -
+  JSR RDXTRACTILETYPE
   BCC +
   LDA #0
+  STA RDENAMEYPE
   LDA #0
   STA STRINGUFFER+16
   LDX #16
-  LDA STRINGUFFER,X
   STA RDENAMEEWAME,X
   DEX
   BPL -
   JSR RDAVEPP
   ;** GET WORKING DIRECTORY FOR NEW-NAME-DIR-SCAN
   LDA RDENAMEEVICE
   ASL
   TAY
   INY
   INY
   INY
   INY
   LDX #0
-  LDA DEVICEABLE,Y
   STA RDORKIR,X
   INY
   INX
   CPX #4
   BCC -
   ;** SCAN DIRECTORY, GET FILE ENTRY
   JSR RDCANIR
   BCS +
   JSR RDESTOREPP
   LDA #ACERRILEXISTS
   STA ERRNO
   SEC
   RTS
   ;** SCAN FOR DIRENT TO MODIFY
+  LDA RDPAVE+0
   LDY RDPAVE+1
   STA ZP+0
   STY ZP+1
   LDY RDENAMECAN
   LDX #0
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INX
   INY
   BNE -
+  JSR RDXTRACTILETYPE
   JSR RDAVEPP
   ;** SCAN DIRECTORY, GET FILE ENTRY
   JSR RDCANIR
   BCC +
   JSR RDESTOREPP
   SEC
   RTS
+  LDX #16
-  LDA RDENAMEEWAME,X
   STA RDIRENTAME,X
   DEX
   BPL -
   LDX #2
-  LDA RDENAMENOWNYPES1,X
   CMP RDENAMEYPE
   BEQ +
   DEX
   BPL -
   JMP ++
+  STA RDIRENTYPE+0
   LDA RDENAMENOWNYPES2,X
   STA RDIRENTYPE+1
   LDA RDENAMENOWNYPES3,X
   STA RDIRENTYPE+2
   ;** WRITE OUT UPDATED DIRECTORY ENTRY
+  LDX #3
-  LDA RDIRENTTR,X
   STA MP,X
   DEX
   BPL -
   LDA #<RDIRENTUF
   LDY #>RDIRENTUF
   STA ZP+0
   STY ZP+1
   LDA #RDIRENTENGTH
   LDY #0
   JSR STASH
   ;** TIDY UP AND EXIT
   JSR RDESTOREPP
   CLC
   RTS

RDENAMENOWNYPES1 .ASC "SPU"
RDENAMENOWNYPES2 .ASC "ERS"
RDENAMENOWNYPES3 .ASC "QGR"

;THE END + BLANK LINE

