;*** ONFIGURATION ROGRAM ***

.SEQ ACEHEAD.S
.SEQ KERNHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:CONFIG"

JMP MAIN
.BYTE "C","",ACE3
.BYTE 64,0

KERNELETLFS  = $FFBA
KERNELETNAM  = $FFBD
KERNELPEN    = $FFC0
KERNELLOSE   = $FFC3
KERNELHKIN   = $FFC6
KERNELHKOUT  = $FFC9
KERNELLRCHN  = $FFCC
KERNELHRIN   = $FFCF
KERNELOAD    = $FFD5
KERNELWAPPER = $FF5F
ST = $90
TOTALANKS .BUF 2
CHR = 13
CHRUOTE = 34

CONFIGUF    = 2   ;(2)
SYSAME      = 4   ;(2)
RAM0REEAP  = 6   ;(2)
ACENDAGE   = 8   ;(1)
SYSYPE      = 9   ;(1)
CHARSET4BIT = 10  ;(2)
MEMEAD      = 12  ;(2)
MEMRITE     = 14  ;(2)
BANKS        = 16  ;(1)
BANKIMIT    = 17  ;(1)
SAVE0        = 18  ;(2)
SAVE2        = 20  ;(2)
SAVE        = 22  ;(2)
TITLETR     = $70 ;(2)

MAIN = *
   LDA #0
   STA ACEOTALEMORY+0
   STA ACEOTALEMORY+1
   STA TOTALANKS+0
   STA TOTALANKS+1
   LDA #<TITLE
   LDY #>TITLE
   STA TITLETR+0
   STY TITLETR+1
   JSR LOADONFIG
   BCS +
   JSR LOADHARSET
   BCS +
   JSR LOADHELL
   BCS +
   JSR LOADHARSET4BIT
   BCS +
   JSR SCREENNIT
   JSR SETATE
   JSR DISPLAYATE
   JSR GETAMLINKARMS
   JSR INTERNALEMORY
   JSR REUEMORY
   JSR RLREUEMORY
   JSR RLEMORY
   LDA TOTALANKS+0
   LDY TOTALANKS+1
   STA ACEOTALEMORY+2
   STY ACEOTALEMORY+3
   JSR TOTALEMORY
   LDX #3
-  LDA ACEREEEMORY,X
   STA ACEOTALEMORY,X
   DEX
   BPL -
   CLC
   LDA #<TITLE
   LDY #>TITLE
   STA 2
   STY 3
   SEC
   LDA TITLETR+0
   SBC #<TITLE
   STA 4
   LDA TITLETR+1
   SBC #>TITLE
   STA 5
   CLC
+  RTS

TESTEMORYYPE = *  ;( .=TYPE, .=BANKIMIT ) : .=BANKOUNT
   STA MP+3
   STX BANKIMIT
   LDA #$00
   LDY #$80  ;** PAGE TO USE FOR TESTING RAM
   LDX #$00
   STA MP+0
   STY MP+1
   STX MP+2
   LDA #0
   STA BANKS

   NEXTANK = *
   LDA BANKS
   STA MP+2
   JSR SAVEANK
   LDA #$FF-$CB
   STA MEMRITE
   LDA MP+2
   STA MEMRITE+1
   LDX #MEMRITE
   LDY #2
   JSR ZPSTORE
   LDA #$FF-$CB
   LDX MP+2
   JSR TESTANK
   BCS BANKAIL
   LDA #$CB
   STA MEMRITE
   LDX #MEMRITE
   LDY #2
   JSR ZPSTORE
   LDA #$CB
   LDX MP+2
   JSR TESTANK
   BCS BANKAIL
   LDA #$CB
   LDX #0
   JSR TESTANK
   BCS BANKAIL
   LDA MP+2
   CMP #2
   BCC +
   LDA #$CB
   LDX #2
   JSR TESTANK
   BCS BANKAIL
+  JSR RESTOREANK
   INC BANKS
   LDA BANKS
   CMP BANKIMIT
   BCC NEXTANK

   BANKAIL = *
   JSR RESTORERAPANKS
   LDA BANKS
   RTS

SAVEANK = *  ;()
   LDX #SAVE
   LDY #2
   LDA MP+2
   CMP #0
   BNE +
   LDX #SAVE0
+  CMP #2
   BNE +
   LDX #SAVE2
+  JSR ZPLOAD
   RTS

RESTOREANK = *  ;()
   LDA MP+2
   CMP #0
   BEQ +
   CMP #2
   BEQ +
   LDX #SAVE
   LDY #2
   JSR ZPSTORE
+  RTS

RESTORERAPANKS = *  ;()
   LDA BANKS
   CMP #3
   BCC +
+  LDA #2
   STA MP+2
   LDX #SAVE2
   LDY #2
   JSR ZPSTORE
   LDA BANKS
   CMP #1
   BCC +
   LDA #0
   STA MP+2
   LDX #SAVE0
   LDY #2
   JSR ZPSTORE
+  RTS

RDAL  = 10  ;(1)
RDANK = 11  ;(1)

TESTANK = *  ;( .=DATA, .=BANK ) : .=ERR
   STA RDAL
   LDA MP+2
   STA RDANK
   STX MP+2
   LDA #$FF
   STA MEMEAD
   STA MEMEAD+1
   LDX #MEMEAD
   LDY #2
   JSR ZPLOAD
   LDA MEMEAD
   CMP RDAL
   BNE +
   LDA MEMEAD+1
   CMP MP+2
   BNE +
   LDA RDANK
   STA MP+2
   CLC 
   RTS
+  LDA RDANK
   STA MP+2
   SEC
   RTS

PUTS = *
   STA $40
   STY $41
   LDY #0
-  LDA ($40),Y
   BEQ +
   JSR CHROUT
   INY
   BNE -
   INC $41
   BNE -
+  RTS

LOADONFIG = *
   LDA #0
   LDX 186
   LDY #0
   JSR KERNELETLFS
   LDA #10
   LDX #<LOADONFIGAME
   LDY #>LOADONFIGAME
   JSR KERNELETNAM
   LDA #0
   LDX CONFIGUF
   LDY CONFIGUF+1
   JSR KERNELOAD
   BCS +
   CLC
   RTS
+  LDA #<BADONFIG
   LDY #>BADONFIG
   JSR PUTS
   SEC
   RTS

   LOADONFIGAME = *
   .ASC "CONFIG.SYS"
   BADONFIG = *
   .ASC "RROR ATTEMPTING TO B-LOAD "
   .BYTE CHRUOTE
   .ASC "CONFIG.SYS"
   .BYTE CHRUOTE
   .ASC ", ABORTING."
   .BYTE CHR,0

LOADHARSET = *
   LDA #0
   LDX 186
   LDY #0
   JSR KERNELETLFS
   LDA #11
   LDX #<LOADHARSETAME
   LDY #>LOADHARSETAME
   JSR KERNELETNAM
   LDA #0
   LDX #<$2000
   LDY #>$2000
   JSR KERNELOAD
   BCS +
   CLC
   RTS
+  LDA #<BADHARSET
   LDY #>BADHARSET
   JSR PUTS
   SEC
   RTS

   LOADHARSETAME = *
   .ASC "ACE-CHARSET"
   BADHARSET = *
   .ASC "RROR ATTEMPTING TO B-LOAD "
   .BYTE CHRUOTE
   .ASC "ACE-CHARSET"
   .BYTE CHRUOTE
   .ASC ", ABORTING."
   .BYTE CHR,0

LOADHELL = *
   LDA #0
   LDX 186
   LDY #0
   JSR KERNELETLFS
   LDA #2
   LDX #<LOADHELLAME
   LDY #>LOADHELLAME
   JSR KERNELETNAM
   LDA #0
   LDX #<ACEHELLDDRESS
   LDY #>ACEHELLDDRESS
   JSR KERNELOAD
   BCS +
   CLC
   RTS
+  LDA #<BADHELL
   LDY #>BADHELL
   JSR PUTS
   SEC
   RTS

   LOADHELLAME = *
   .ASC "SH"
   BADHELL = *
   .ASC "RROR ATTEMPTING TO B-LOAD "
   .BYTE CHRUOTE
   .ASC "SH"
   .BYTE CHRUOTE
   .ASC ", ABORTING."
   .BYTE CHR,0

LOADHARSET4BIT = *
   LDA SYSYPE
   CMP #64
   BNE LOADH4XIT
   LDY #$C0
   LDA (CONFIGUF),Y
   BPL LOADH4XIT
   LDA #0
   LDX 186
   LDY #0
   JSR KERNELETLFS
   LDA #16
   LDX #<LOADH4AME
   LDY #>LOADH4AME
   JSR KERNELETNAM
   LDA #0
   LDX #<CHAR4BITUF
   LDY #>CHAR4BITUF
   JSR KERNELOAD
   BCS +
   SEI
   LDA #$30
   STA $01
   LDX #0
-  LDA CHAR4BITUF+$000,X
   STA $D800,X
   LDA CHAR4BITUF+$100,X
   STA $D900,X
   LDA CHAR4BITUF+$200,X
   STA $DA00,X
   LDA CHAR4BITUF+$300,X
   STA $DB00,X
   INX
   BNE -
   LDA #$36
   STA $01
   CLI
   LOADH4XIT = *
   CLC
   RTS
+  LDA #<BADH4
   LDY #>BADH4
   JSR PUTS
   SEC
   RTS

   LOADH4AME = *
   .ASC "ACE-CHARSET-4BIT"
   BADH4 = *
   .ASC "RROR ATTEMPTING TO B-LOAD "
   .BYTE CHRUOTE
   .ASC "ACE-CHARSET-4BIT"
   .BYTE CHRUOTE
   .ASC ", ABORTING."
   .BYTE CHR,0

SCREENNIT = *
   LDA #147
   JSR $FFD2
   LDA SYSAME+0
   LDY SYSAME+1
   JSR PUTS
   RTS

DISPLAYATE = *
   LDA #<DATEUF
   LDY #>DATEUF
   JSR GETDATE
   ;** YEAR
   LDA DATEUF+0
   LDX #11
   JSR PUTIGITS
   LDA DATEUF+1
   LDX #13
   JSR PUTIGITS
   ;** MONTH
   LDA DATEUF+2
   CMP #$10
   BCC +
   SEC
   SBC #$10-10
+  TAX
   LDA MONTHTR+0,X
   STA DATETR+7
   LDA MONTHTR+13,X
   STA DATETR+8
   LDA MONTHTR+26,X
   STA DATETR+9
   ;** DAY
   LDA DATEUF+3
   LDX #4
   JSR PUTIGITS
   ;** HOUR
   LDA DATEUF+4
   LDX #"A"
   CMP #$00
   BNE +
   LDA #$12
   JMP PUTOUR
+  CMP #$12
   BCC PUTOUR
   LDX #"P"
   CMP #$12
   BEQ PUTOUR
   SEI
   SED
   SEC
   SBC #$12
   CLD
   CLI
   PUTOUR = *
   STX DATETR+26
   LDX #17
   JSR PUTIGITS
   ;** MINUTE
   LDA DATEUF+5
   LDX #20
   JSR PUTIGITS
   ;** SECOND
   LDA DATEUF+6
   LDX #23
   JSR PUTIGITS
   ;** DAY OF WEEK
   LDA DATEUF+7
   AND #$07
   TAX
   LDA DOWTR+0,X
   STA DATETR+0
   LDA DOWTR+8,X
   STA DATETR+1
   LDA DOWTR+16,X
   STA DATETR+2
   LDA #<DATETR
   LDY #>DATETR
   JSR PUTS
   RTS

   PUTIGITS = *  ;( .=NUM, .=OFFSET )
   PHA
   LSR
   LSR
   LSR
   LSR
   ORA #$30
   STA DATETR,X
   PLA
   AND #$0F
   ORA #$30
   STA DATETR+1,X
   RTS
 
   DATETR = *
        ;0123456789012345678901234567
   .ASC "UE-05-AY-1993  11:34:12 PM"
   .BYTE 13,13,0
   DATEUF .BUF 10
   DOWTR = *
   .ASC "*"
   .ASC "*UOUEHRA"
   .ASC "*NNEDUIT"
   MONTHTR = *
   .ASC "*"
   .ASC "*AEAPAUUUECOE"
   .ASC "*NBRRYNLGPTVC"

TRYATE = 10

SETATE = *
   LDY #$82
-  STY TRYATE
   LDA (CONFIGUF),Y
   CMP #$FF
   BEQ +
   JSR CMDPEN
   BCS +
   LDA #<QUERYATETR
   LDY #>QUERYATETR
   JSR CMDEND
   BCS QUERYRROR
   LDA #<DATEUF
   LDY #>DATEUF
   LDX #9
   JSR CMDATA
   BCS QUERYRROR
   JSR CMDLOSE
   JMP CONVERTMDATE

   QUERYRROR = *
   JSR CMDLOSE
+  INC TRYATE
   LDY TRYATE
   CPY #$86
   BCC -

   SETEFAULTATE = *
   LDA CONFIGUF
   LDY CONFIGUF+1
   CLC
   ADC #$86
   BCC +
   INY
+  JMP SETDATE

   QUERYATETR = *
   .ASC "T-RB"
   .BYTE 13,0

CONVERTMDATE = *
   LDA DATEUF+4
   LDX DATEUF+7
   BEQ +
   SEI
   SED
   CLC
   ADC #$12
   CLD
   CLI
+  CMP #$12
   BNE +
   LDA #$00
+  CMP #$24
   BNE +
   LDA #$12
+  STA DATEUF+4
   CLC
   LDA DATEUF+0
   ADC #$51
   STA DATEUF+7
   LDX #$19
   LDA DATEUF+1
   CMP #$70
   BCS +
   LDX #$20
+  STX DATEUF+0
   LDA #<DATEUF
   LDY #>DATEUF
   JSR SETDATE
   RTS

CMDPEN = *  ;( .=DEVICE ) : .=ERR
   TAX
   LDA #6
   LDY #15
   JSR KERNELETLFS
   LDA #0
   JSR KERNELETNAM
   JSR KERNELPEN
   RTS

CMDLOSE = *  ;()
   CLC
   LDA #6
   JSR KERNELLOSE
   RTS

CMDEND = *  ;( (.)=CMDTR ) : .=ERR
   STA $40
   STY $41
   LDX #6
   JSR KERNELHKOUT
   BCC +
   RTS
+  LDY #0
-  LDA ($40),Y
   BEQ +
   JSR $FFD2
   INY
   BNE -
+  JSR KERNELLRCHN
   CLC
   RTS

CMDATA = *  ;( (.)=CMDUF, .=LEN ) : .=ERR
   STA $40
   STY $41
   STX $42
   LDX #6
   JSR KERNELHKIN
   BCC +
   RTS
+  LDX #0
   JSR KERNELHRIN
   CMP #"0"
   BCC ++
   CMP #"9"+1
   BCS ++
   BADATA = *
-  JSR KERNELHRIN
   BCS +
   BIT ST
   BVS +
   CMP #13
   BNE -
+  JSR KERNELLRCHN
   SEC
   RTS
+  LDY #0
   STA ($40),Y
   INY
-  JSR KERNELHRIN
   STA ($40),Y 
   INY
   CPY $42
   BCC -
   CMP #13
   BNE BADATA
   JSR KERNELLRCHN
   CLC
   RTS

GETAMLINKARMS = *
   LDY #$80
   LDA (CONFIGUF),Y
   JSR CMDPEN
   BCS RLARMSRROR

   ;** RAMLINK RAM ACCESS
   LDA #<PARTLMD
   LDY #>PARTLMD
   JSR CMDEND
   BCS RLARMSRROR
   LDA #<RLDENT
   LDY #>RLDENT
   JSR CHECKARTITION
   BCS +
   STA ACEAMLINKTART
   STY ACEAMLINKTART+1
   STX ACEAMLINKANKS

   ;** INDIRECT REU ACCESS
+  LDA #<PARTLREUMD
   LDY #>PARTLREUMD
   JSR CMDEND
   BCS RLARMSRROR
   LDA #<RLREUDENT
   LDY #>RLREUDENT
   JSR CHECKARTITION
   BCS RLARMSRROR
   STA ACEAMLINKEUTART
   STY ACEAMLINKEUTART+1
   STX ACEAMLINKEUANKS

   RLARMSRROR = *
   JSR CMDLOSE
   RTS

CHECKARTITION = *  ;( (.)=NAME ) : .=ERR, .=START, .=BANKS
   STA $44
   STY $45
   LDA #<PARTITIONUF
   LDY #>PARTITIONUF
   LDX #31
   JSR CMDATA
   BCS CHECKRRXIT
   LDA PARTITIONUF+0
   CMP #7
   BNE CHECKRRXIT
   LDY #0
-  LDA ($44),Y
   BEQ +
   CMP PARTITIONUF+3,Y
   BNE CHECKRRXIT
   INY
   BNE -
+  LDA PARTITIONUF+21
   LDY PARTITIONUF+20
   LDX PARTITIONUF+28
   CLC
   RTS

   CHECKRRXIT = *
   SEC
   RTS

PARTLMD = *
   .ASC "G-P"
   .BYTE 31,0
RLDENT = *
   .ASC "RL-RAM"
   .BYTE $A0,0
PARTLREUMD = *
   .ASC "G-P"
   .BYTE 30,0
RLREUDENT = *
   .ASC "INDIRECT-REU"
   .BYTE $A0,0
PARTITIONUF .BUF 35

PUTNUM = *  ;( [$44]=NUM, .=WIDTH )
   PHA
   LDA #<OUTCHAR
   LDY #>OUTCHAR
   STA ZP+0
   STY ZP+1
   LDX #$44
   PLA
   JSR UTOA
   JSR PUTCOMMA
   LDX #0
-  LDA OUTCHAR,X
   BEQ +
   JSR CHROUT
   INX
   BNE -
+  RTS
   OUTCHAR .BUF 11

PUTCOMMA = *  ;( OUTCHAR )
   LDX #$FF
-  INX
   LDA OUTCHAR,X
   BNE -
-  DEX
   DEX
   DEX
   DEX
   CPX #$80
   BCC +
   RTS
+  CPX #0
   BCS +
   RTS
+  LDA OUTCHAR,X
   CMP #" "
   BNE +
   RTS
+  STX $44
   LDY #0
-  LDA OUTCHAR+1,Y
   STA OUTCHAR,Y
   INY
   CPY $44
   BCC -
   LDA #"_"
   STA OUTCHAR,Y
   JMP --
   RTS

DISPLAYVAIL = *  ;( (.)=NAME, (.,$45)=BANKS )
   STA $40
   STY $41
   STX $44
   LDY #0
-  LDA ($40),Y
   JSR CHROUT
   INY
   CPY #6
   BCC -
   LDA #":"
   JSR CHROUT
   TXA
   CLC
   ADC TOTALANKS
   STA TOTALANKS
   LDA $45
   ADC TOTALANKS+1
   STA TOTALANKS+1
   LDA #0
   STA $46
   STA $47
   LDX #6
-  ASL $44
   ROL $45
   ROL $46
   ROL $47
   DEX
   BNE -
   LDA #6
   JSR PUTNUM
   LDA #""
   JSR CHROUT
   RTS

ADDOREE = *  ;( [$44]=BYTES )
   CLC
   LDA $44
   ADC ACEREEEMORY+0
   STA ACEREEEMORY+0
   LDA $45
   ADC ACEREEEMORY+1
   STA ACEREEEMORY+1
   LDA $46
   ADC ACEREEEMORY+2
   STA ACEREEEMORY+2
   BCC +
   INC ACEREEEMORY+3
+  RTS

DISPLAYREE = *  ;( [$44]=BYTES )
   LDA #<FREESG
   LDY #>FREESG
   JSR PUTS
   LDA #10
   JSR PUTNUM
   LDA #13
   JSR CHROUT
   RTS
   FREESG = *
   .ASC "   FREE:"
   .BYTE 0

RESETREE = *
   LDA #0
   LDX #3
-  STA $44,X
   DEX
   BPL -
   RTS

INTERNALEMORY = *
   LDA #ACEEMNTERNAL
   LDX #255
   SEI
   JSR TESTEMORYYPE
   CLI
   STA ACENTERNALANKS
   PHA
   JSR INSTALLNTERNECTORS
   PLA
   TAX
   LDA #0
   STA $45
   LDA #<INTERNALAME
   LDY #>INTERNALAME
   JSR DISPLAYVAIL
   JSR RESETREE

   ;** RAM0
   LDA #ACEEMNTERNAL
   STA MP+3
   LDA #0
   STA ACENTERNALUR
   LDA RAM0REEAP+0
   LDY RAM0REEAP+1
   STA ACEAM0REEMAP+0
   STY ACEAM0REEMAP+1
   LDX #0
   STA MP+0
   STY MP+1
   STX MP+2
   LDY #$A3
   BIT SYSYPE
   BMI +
   LDY #$C1
+  LDA (CONFIGUF),Y
   TAY
   LDA #1
   LDX #>ACEPPDDRESS
   JSR INITANKS
   JSR FREEAM0FTERERNEL

   ;** RAM1
   BIT SYSYPE
   BPL EXPNTERNAL64
   LDA #$00
   STA MP+0
   LDY #$A0
   LDA (CONFIGUF),Y
   STA MP+1
   STA ACEAM1REEMAP
   LDA #1
   STA MP+2
   LDY #$A1
   LDA (CONFIGUF),Y
   TAY
   LDA #2
   LDX MP+1
   INX
   JSR INITANKS

   ;** RAM2-7 C128
   EXPNTERNAL128 = *
   LDA #2
   STA MP+2
   LDA #$00
   LDY #$04
   STA MP+0
   STY MP+1
   LDY #$A5
   LDA (CONFIGUF),Y
   LDX ACENTERNALANKS
   JSR MIN
   STA ACENTERNALANKS
   LDX #$05
   LDY #$FF
   JSR INITANKS
   JSR ADDOREE
   JSR DISPLAYREE
   RTS

   ;** RAM1-3 C64
   EXPNTERNAL64 = *
   LDA #1
   STA ACENTERNALANKS
   JSR ADDOREE
   JSR DISPLAYREE
   RTS

   INTERNALAME = *
   .ASC "INTERN"

RESERVE = *
   LDY #$A8
   BIT SYSYPE
   BMI +
   LDY #$C6
+  LDA (CONFIGUF),Y
   STA $40
   LDY #>ACEPPDDRESS
   LDA #$FE
   CPY $40
   BCS +
-  STA (RAM0REEAP),Y
   INY
   CPY $40
   BCC -
+  SEC
   LDA $40
   SBC #>ACEPPDDRESS
   STA $40
   SEC
   LDA ACEREEEMORY+1
   SBC $40
   STA ACEREEEMORY+1
   LDA ACEREEEMORY+2
   SBC #0
   STA ACEREEEMORY+2
   LDA ACEREEEMORY+3
   SBC #0
   STA ACEREEEMORY+3
   RTS

RESERVEIC80 = *
   BIT SYSYPE
   BVS +
-  RTS
+  LDY #$C0
   LDA (CONFIGUF),Y
   BPL -
   LDA #$FC
   LDY #$D8
-  STA (RAM0REEAP),Y
   INY
   CPY #$FF
   BCC -
   SEC
   LDA ACEREEEMORY+1
   SBC #$FF-$D8
   STA ACEREEEMORY+1
   LDA ACEREEEMORY+2
   SBC #0
   STA ACEREEEMORY+2
   LDA ACEREEEMORY+3
   SBC #0
   STA ACEREEEMORY+3
   RTS

FREEAM0FTERERNEL = *
   ;** FREE END.KERNEL->ST.SHELL
   LDY ACENDAGE
   CPY #>ACEPPDDRESS
   BCS +
   LDA #$00
-  STA (RAM0REEAP),Y
   INY
   CPY #>ACEPPDDRESS
   BCC -
+  SEC
   LDA #>ACEPPDDRESS
   SBC ACENDAGE
   STA $40
   CLC
   LDA $45
   ADC $40
   STA $45
   BCC +
   INC $46
   BNE +
   INC $47
+  RTS

INSTALLNTERNECTORS = *
   BIT SYSYPE
   BPL INSTALLECTORS64
   LDA ACENTERNALANKS
   CMP #2
   BCS +
   RTS
+  SEI
   LDA #2
   LDY #ACEEMNTERNAL
   STA MP+2
   STY MP+3
-  LDA #$05
   LDY #$FF
   STA MP+0
   STY MP+1
   STA ZP+0
   STY ZP+1
   LDA #<251
   LDY #>251
   JSR STASH
   INC MP+2
   LDA MP+2
   CMP ACENTERNALANKS
   BCC -
   CLI
   RTS

INSTALLECTORS64 = *
   ;XX COPY TO EXP BANKS
   RTS

REUEMORY = *
   LDA #ACEEM
   LDX #255
   JSR TESTEMORYYPE
   STA ACEEUANKS
   TAX
   BNE +
   LDA ACEAMLINKEUANKS
   BEQ +
   RTS
+  LDA #0
   STA $45
   LDA #<REUAME
   LDY #>REUAME
   JSR DISPLAYVAIL
   JSR RESETREE
   LDA #ACEEM
   STA MP+3
   LDY #$A6
   BIT SYSYPE
   BMI +
   LDY #$C2
+  LDA (CONFIGUF),Y
   STA ACEEUTART
   STA ACEEUUR
   LDY #$A7
   BIT SYSYPE
   BMI +
   LDY #$C3
+  LDA (CONFIGUF),Y
   LDX ACEEUANKS
   JSR MIN
   STA ACEEUANKS
   LDA #$00
   LDY #$FF
   LDX ACEEUTART
   STA MP+0
   STY MP+1
   STX MP+2
   LDA ACEEUANKS
   LDX #$00
   LDY #$FF
   JSR INITANKS
   JSR ADDOREE
   JSR DISPLAYREE
   RTS
   REUAME = *
   .ASC "REU   "

RLREUEMORY = *
   LDA ACEEUANKS
   BEQ +
   LDA #0
   STA ACEAMLINKEUANKS
-  RTS
+  LDX ACEAMLINKEUANKS
   BEQ -
   LDA #0
   STA $45
   LDA #<RLREUAME
   LDY #>RLREUAME
   JSR DISPLAYVAIL
   JSR RESETREE
   LDA #ACEEM
   STA MP+3
   LDY #$A6
   BIT SYSYPE
   BMI +
   LDY #$C2
+  LDA (CONFIGUF),Y
   STA ACEEUTART  ;**SIC
   STA ACEAMLINKEUUR
   LDY #$A7
   BIT SYSYPE
   BMI +
   LDY #$C3
+  LDA (CONFIGUF),Y
   LDX ACEAMLINKEUANKS
   JSR MIN
   STA ACEAMLINKEUANKS
   LDA #$00
   LDY #$FF
   LDX ACEAMLINKEUTART
   STA MP+0
   STY MP+1
   STX MP+2
   LDA ACEAMLINKEUANKS
   LDX #$00
   LDY #$FF
   JSR INITANKS
   JSR ADDOREE
   JSR DISPLAYREE
   RTS
   RLREUAME = *
   .ASC "RL-REU"

RLEMORY = *
   LDX ACEAMLINKANKS
   LDA #0
   STA $45
   LDA #<RLAME
   LDY #>RLAME
   JSR DISPLAYVAIL
   JSR RESETREE
   LDY #$81
   LDA (CONFIGUF),Y
   LDX ACEAMLINKANKS
   JSR MIN
   STA ACEAMLINKANKS
   LDA #ACEEM
   STA MP+3
   LDA #$00
   LDY #$FF
   LDX #0
   STX ACEAMLINKUR
   STA MP+0
   STY MP+1
   STX MP+2
   LDA ACEAMLINKANKS
   LDX #$00
   LDY #$FF
   JSR INITANKS
   JSR ADDOREE
   JSR DISPLAYREE
   RTS
   RLAME = *
   .ASC "RL-RAM"

TOTALEMORY = *
   LDX TOTALANKS
   LDA TOTALANKS+1
   STA $45
   LDA #<TOTALAME
   LDY #>TOTALAME
   JSR DISPLAYVAIL
   LDX #3
-  LDA ACEREEEMORY,X
   STA $44,X
   DEX
   BPL -
   JSR DISPLAYREE
   LDA #13
   JSR CHROUT
   JSR RESERVE
   JSR RESERVEIC80
   RTS
   TOTALAME = *
   .ASC "TOTAL "
   RTS

ENDANK   = 10  ;(1)
STARTREE = 11  ;(1)
ENDREE   = 12  ;(1)

INITANKS = *  ;( [MP]=FIRSTREEMAP, .=ENDANK+1, .=STARTREE, .=ENDREE+1 )
   STA ENDANK
   STX STARTREE
   STY ENDREE
   LDA #<FREEMAP
   LDY #>FREEMAP
   STA ZP+0
   STY ZP+1
   LDX #0
   LDA #$FF
-  STA FREEMAP,X
   INX
   BNE -
   LDX STARTREE
   CPX ENDREE
   BCS FREEEXTANK
   LDA #$00
-  STA FREEMAP,X
   INX
   CPX ENDREE
   BCC -

   FREEEXTANK = *
   LDA MP+2
   CMP ENDANK
   BCS +
   LDA #<256
   LDY #>256
   JSR STASH
   INC MP+2
   SEC
   LDA ENDREE
   SBC STARTREE
   CLC
   ADC $45
   STA $45
   BCC FREEEXTANK
   INC $46
   BNE FREEEXTANK
   INC $47
   JMP FREEEXTANK
+  RTS

MIN = *  ;( .=NUM1, .=NUM2 ) : .=MIN
   STX $40
   CMP $40
   BCC +
   LDA $40
+  RTS

CHROUTAVE .BUF 1

CHROUT = *
   JSR $FFD2
   STY CHROUTAVE
   LDY #0
   STA (TITLETR),Y
   INC TITLETR+0
   BNE +
   INC TITLETR+1
+  LDY CHROUTAVE
   CLC
   RTS

BSS = *
FREEMAP = BSS+0
TITLE = FREEMAP+256
CHAR4BITUF = TITLE+512
BSSND = CHAR4BITUF+1024
