;*** RM PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:RM"

JMP REMOVEAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $60

CHR = $0D
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

;===REMOVE LIBRARY===
GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

;===REMOVE===
RMRG = 2
RMAME = 4

REMOVEAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE RMNOUGHRGS
   LDA ACERGC
   CMP #2
   BCS RMNOUGHRGS

RMSAGE = *
   LDA #<RMSAGESG
   LDY #>RMSAGESG
   JMP PUTS

RMSAGESG = *
   .ASC "SAGE: RM FILE1 FILE2 ... FILE"
   .BYTE CHR
   .BYTE 0

RMNOUGHRGS = *
   LDA #1
   LDY #0
   STA RMRG
   STY RMRG+1
-  LDA RMRG
   LDY RMRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA RMAME
   STY RMAME+1
   ORA ZP+1
   BEQ RMXIT
   JSR STOPKEY
   BCS STOPPED
   JSR RMCHO
   LDA RMAME
   LDY RMAME+1
   STA ZP
   STY ZP+1
   JSR REMOVE
   BCC +
   JSR RMRROR
+  INC RMRG
   BNE +
   INC RMRG+1
+  JMP -

RMXIT = *
   RTS

STOPPED = *
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JMP EPUTS
   STOPPEDSG = *
   .ASC "<STOPPED>"
   .BYTE CHR,0

RMRROR = *
   LDA #<RMRRORSG1
   LDY #>RMRRORSG1
   JSR EPUTS
   LDA RMAME
   LDY RMAME+1
   JSR EPUTS
   LDA #<RMRRORSG2
   LDY #>RMRRORSG2
   JMP EPUTS

RMRRORSG1 = *
   .ASC "RROR ATTEMPTING TO REMOVE "
   .BYTE CHRUOTE
   .BYTE 0

RMRRORSG2 = *
   .BYTE CHRUOTE
   .BYTE CHR
   .BYTE 0

RMCHO = *
   LDA #<RMCHOSG1
   LDY #>RMCHOSG1
   JSR EPUTS
   LDA RMAME
   LDY RMAME+1
   JSR EPUTS
   LDA #<RMCHOSG2
   LDY #>RMCHOSG2
   JMP EPUTS

RMCHOSG1 = *
   .ASC "EMOVING FILE "
   .BYTE CHRUOTE,0

RMCHOSG2 = *
   .BYTE CHRUOTE
   .ASC "..."
   .BYTE CHR,0

;===THE END===
RMND = *
